package lair;

import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

import java.util.Random;


public class EvilPlan extends Agent {	
		
	private int progress = 0;
	private boolean broken = false;
		
	protected void setup () { 		
		
		addBehaviour(new CyclicBehaviour(this) {
			public void action() {
				ACLMessage msg = blockingReceive();
			
				switch(msg.getContent()) {
					case "end":
						EvilPlan.this.takeDown();
						break;
					case "work":
						if (!EvilPlan.this.broken) {
							EvilPlan.this.progress = EvilPlan.this.progress + 10;
							
							if (EvilPlan.this.progress > 100) {
								System.out.println("The Evil Plan was already finished! This Minions are true workaholics!");
							} else {
								System.out.println("The Evil Plan's progress is " + EvilPlan.this.progress + ".");	
							}
						} else {
							System.out.println("All progress was in vain. The Evil Plan is broken.");
						}
						break;
					case "break":
						EvilPlan.this.broken = true;
						if (!EvilPlan.this.broken) {
							System.out.println("Oh, no! The Evil Plan has broken!");
						} else {
							System.out.println("The Evil Plan has broken even further!");
						}
						break;
				}
				
				if (EvilPlan.this.broken) {
					Random rand = new Random();
					int repair = rand.nextInt(100);
					
					if (repair >= 50) {
						EvilPlan.this.broken = false;
						System.out.println("Thankfully, Dr Nefario was able to repair the Evil Plan.");
					}				
				}
				
			} 
		});

		ACLMessage msg = blockingReceive();
		System.out.println("The Evil Plan starts.");
							
	}	
	
	
	// Put agent clean-up operations here
	protected void takeDown() {	
		ACLMessage msg = new ACLMessage( ACLMessage.INFORM );
		msg.addReceiver(new AID("Gru", AID.ISLOCALNAME));
		msg.setContent(Integer.toString(EvilPlan.this.progress));
		send(msg);
		this.doDelete();
	}
	
}