package lair;

import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

import java.util.Random;

public class Gru extends Agent {
	
	
	protected void setup () { 
	
		System.out.println(getLocalName() + " enters his evil lair.");
		
		// Choose a plan and enable Minions.
		addBehaviour(new WakerBehaviour(this, 2000) {
			private String plans[] = {"replace the human population with Jackie Chan look-alikes.",
									  "host a TV show with a Teletubby.",
									  "handcuff (for life, if possible) Justin Bieber to a train.",
									  "make a Cat Gun (WTF, seriously, who wrote this? Was it you, Dave?) that will fire cats that scratch at his face."};
			
			public void onWake() {			
				Random rand = new Random();
				int say = rand.nextInt(this.plans.length);
				System.out.println(getLocalName() + " says: Hello, my Minions! Today, we start a new era.");
				System.out.println("\tHere, I' have the ULTIMATE plan. The one that will drown that stupid other villian on the rankings for ever.");
				System.out.println("\tYes, yes, I know we've had our ups and downs... But we will rise again! And THIS is the plan: *reading* " + this.plans[say]);
				System.out.println("\tAnyway, you know what you have to do. GET TO WORK!");

				startAction();
			}
		});
		

	}
	
	
	private void startAction() {
		
		addBehaviour(new OneShotBehaviour(this) {
			public void action() {
				//Enable plan and minions			
				ACLMessage msg = new ACLMessage( ACLMessage.INFORM );
				msg.addReceiver(new AID("EvilPlan", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Bob", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Stuart", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Kevin", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Dave", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Jerry", AID.ISLOCALNAME));
				send(msg);
			}
		});
				
		addBehaviour(new WakerBehaviour(this, 10000) {
			public void onWake() {
				System.out.println(getLocalName() + " says: Minions! There's no more time! We must execute the Evil Plan NOW! Let's see...");
				
				// Parar minions
				
				// Terminar el Plan Malvado y recibir el progreso
				ACLMessage msg = new ACLMessage( ACLMessage.INFORM );
				msg.addReceiver(new AID("EvilPlan", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Bob", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Stuart", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Kevin", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Dave", AID.ISLOCALNAME));
				msg.addReceiver(new AID("Jerry", AID.ISLOCALNAME));
				msg.setContent("end");
				send(msg);
				
				msg = blockingReceive();
								
				if (msg != null) {
					int progress = Integer.parseInt(msg.getContent());
					if (progress == 100) {
						System.out.println("Muajajajaja, there's no way that stupid will defeat me again!");
						
					} else if (progress > 100) {
						System.out.println("Wow! You did a great job, you guys! Muajajajaja, no one can stop me now!");
						
					} else {
						System.out.println("Whaaaaaaaaaat's this? *sigh* Anyway. It will have to do. Let's go.");				
					}
				} else {
					System.out.println("Woah? What happened? There must be an error. Where did my Evil Plan go?");
				}
				
			} 
			
		});
	}

	
}