package lair;

import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

import java.util.Random;


public class Minion extends Agent {	
	
	private String[] phrases = {"Work!", "Get to work!", "WOOOOOOOOOOOOOOOOOOORK!", "Work, work, work!", "Work? :("};

	class SingleStepBehaviour extends OneShotBehaviour {
	    private String activity;

	    public SingleStepBehaviour(String act) {
	      activity = act;
	    }

	    public void action() {
		  Random rand = new Random();
		  int match = rand.nextInt(100);
		  String result = "lost";
		  if (match >= 50) result = "won";
	      System.out.println(getName() + " decided to " + this.activity + " and... " + result + "!" );
	    } 

	    public int onEnd() {
	        reset();
	        return super.onEnd();
	    }
	}
	  
	protected void setup () { 			
		Random rand = new Random();
		
		int behaviour;	
		for ( int i = 0; i < 2; i++ ) {
			behaviour = (rand.nextInt()%(300 - 100)+ 100)/100;	// [1, 3]
			
			switch(behaviour) {
				case 1:		
					addBehaviour(new TickerBehaviour(this, 2000) {
						private String[] phrases = {"Bello! ^^", "Poopaye! ^^", 
													"Tank yu! :D", "Banana! *-*", "Po ka... :O",
													"Me want banana! :(", "Para tu, pupete! :D", "Tatata bala tu >.<",
													"Hana... Dul... Sae...", "Kan pai :D", "Pwede na?", "Bi do U.U"		
													};
						public void onTick() {
							ACLMessage msg = myAgent.receive();
							if (msg != null) {
								Minion.this.takeDown();
							}
							
							Random rand = new Random();
							int shouldIWork = rand.nextInt(100);
							
							if (shouldIWork >= 95) {
								Minion.this.work();
			
							} else if (shouldIWork >= 75) {
								Minion.this.work();
								int breakIt = rand.nextInt(100);
								if (breakIt >= 85) 
									Minion.this.breakPlan();
							
							} else {	
								int say = rand.nextInt(this.phrases.length);		
								System.out.println(getLocalName() + " says: " + this.phrases[say]);
							}						
							
						} 
					});
					break;
				case 2:
					// Add three step behaviour*/
					addBehaviour(new ThreeStepBehaviour());	
					break;
				case 3:
					System.out.println(getLocalName() + " feels like doing nothing today!");
					
					SequentialBehaviour mySequentialBehaviour = new SequentialBehaviour();
								
					mySequentialBehaviour.addSubBehaviour(new SingleStepBehaviour("play football"));
					mySequentialBehaviour.addSubBehaviour(new SingleStepBehaviour("play videogames with the girls"));
					mySequentialBehaviour.addSubBehaviour(new SingleStepBehaviour("bet with Dr Nefario to a pulse"));
					mySequentialBehaviour.addSubBehaviour(new SingleStepBehaviour("challenge Robbie to eat ice creams"));							
							
					addBehaviour(mySequentialBehaviour);
					break;
			}
			
		}
			
		ACLMessage msg = blockingReceive();
		System.out.println(getLocalName() + " yells: " + this.phrases[rand.nextInt(this.phrases.length)]);
			
	}
	
	/**
	* Inner class FourStepBehaviour
	*/
	private class ThreeStepBehaviour extends Behaviour {
		private int step = 1;
		
		public void onStart() {
			System.out.println(getLocalName() + " feels like working today!");
		}
	
		public void action() {
			ACLMessage msg = myAgent.receive();
			if (msg != null) {
				Minion.this.takeDown();
			}
							
			switch (step) {
			case 1:
				Minion.this.work();
				break;
			case 2:
				Minion.this.work();
				Random rand = new Random();
				int breakIt = rand.nextInt(100);
				if (breakIt >= 85) 
					Minion.this.breakPlan();
				break;
			case 3:
				Minion.this.work();
				break;
			}
			step++;
		} 

		public boolean done() {
			return step == 4;
		} 

		public int onEnd() {
			Minion.this.doDelete();
			return super.onEnd();
		} 
	}    // END of inner class FourStepBehaviour

	
	private void work() {
		System.out.println(getLocalName() + " is working.");
		ACLMessage msg = new ACLMessage( ACLMessage.INFORM );
		msg.addReceiver(new AID("EvilPlan", AID.ISLOCALNAME));
		msg.setContent("work");
		send(msg);
	}
	
	private void breakPlan() {
		System.out.println("Oops! " + getLocalName() + " broke the plan!");
		ACLMessage msg = new ACLMessage( ACLMessage.INFORM );
		msg.addReceiver(new AID("EvilPlan", AID.ISLOCALNAME));
		msg.setContent("break");
		send(msg);
	}
	
	// Put agent clean-up operations here
	protected void takeDown() {
		// Printout a dismissal message
		System.out.println(getLocalName() + " leaves after Gru.");
		this.doDelete();
	}
}